# frozen_string_literal: true

module Jsonschema
  module Matchers
    # Generates correct file path
    class Metadater
      class << self
        def call(metadata)
          raise Error, 'Argument is not a Hash' unless metadata.is_a?(Hash)

          description = if metadata[:description].empty?
                          metadata[:scoped_id]
                        else
                          metadata[:description].tr(' ', '_')
                        end

          example_group = metadata[:parent_example_group]

          generate(example_group, description)
        end

        private

        def generate(example_group, description)
          if example_group
            [call(example_group), description].join('/')
          else
            description
          end
        end
      end
    end
  end
end
